package com.hisschemoller.audio.model 
{
	import com.hisschemoller.audio.model.vo.ProgramVO;

	import org.puremvc.as3.multicore.patterns.proxy.Proxy;

	/**
	 * @author wouterhisschemoller
	 */
	public class BaseInstrumentProxy extends Proxy 
	{
		protected var _selectedProgramIndex : int;
		protected var _isReadyToPlay : Boolean;
		
		public function BaseInstrumentProxy ( name : String )
		{
			super( name );
		}
		
		/**
		 * For the audio engine to identify instruments.
		 */
		public function get id () : String
		{
			return getProxyName( );
		}
		
		/**
		 * @return int program index or -1 if all program slots are occupied.
		 */
		protected function getValidProgramIndex( programs : Vector.<ProgramVO>, preferredIndex : uint = 0 ) : int
		{
			var programIndex : int = -1;
			
			if( preferredIndex < programs.length )
			{
				/** A valid index was found. */
				programIndex = preferredIndex;
			}
			else
			{
				/** No valid index found. Search first available slot. */
				var n : uint = programs.length;
				for(var i : uint = 0;i < n; i++)
				{
					if(programs[n] == null)
					{
						programIndex = n;
						break;
					}
				}
			}
			
			return programIndex;
		}
	}
}
