package com.hisschemoller.audio.model.vo 
{
	import com.hisschemoller.audio.model.enum.AudioProcessorType;

	/**
	 * @author Wouter Hisschemöller
	 * (c) Jun 4, 2009
	 */
	public class PitchedSampleProgramVO extends SampleProgramVO
	{
		public var start : int;
		public var end : int;
		public var reverse : Boolean;
		public var transpose : Number = 0;
		public var tune : Number = 0;

		public function PitchedSampleProgramVO()
		{
			super();
			
			super.type = AudioProcessorType.PITCHED_SAMPLE_PROCESSOR;
		}

		override public function parseXML(o : XML) : Boolean
		{
			var result : Boolean = super.parseXML(o);
			
			start = o.@start;
			end = o.@end;
			reverse = o.@reverse;
			transpose = o.@transpose;
			tune = o.@tune;
			
			return result;
		}

		override public function clone() : ProgramVO
		{
			var programVO : PitchedSampleProgramVO = new PitchedSampleProgramVO();
			programVO.id = id;
			programVO.type = type;
			programVO.soundID = soundID;
			programVO.start = start;
			programVO.end = end;
			programVO.reverse = reverse;
			programVO.transpose = transpose;
			programVO.tune = tune;
			
			return programVO;
		}
	}
}
