package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.vo.TrackVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;
	/**
	 * @author Wouter Hisschemoller
	 * (c) Jan 8, 2011
	 */
	public class AddNewTrackCommand extends SimpleCommand 
	{
		/**
		 * Add new track to sequencer and possible other interested parties.
		 */
		override public function execute ( note : INotification ) : void 
		{
			var trackVO : TrackVO = note.getBody() as TrackVO;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			sequencerProxy.addTrack( trackVO );

			sendNotification( SeqNotifications.SEQ_TRACK_ADDED, trackVO );
		}
	}
}
