package com.hisschemoller.sequencer.controller
{
	import com.hisschemoller.audio.model.AudioLibraryProxy;
	import com.hisschemoller.sequencer.model.ProjectProxy;
	import com.hisschemoller.ui.notification.UINotifications;

	import org.puremvc.as3.multicore.interfaces.ICommand;
	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;

	/**
	 * @author wouter.hisschemoller
	 * Oct 12, 2010
	 */
	public class BusyCommand extends SimpleCommand implements ICommand 
	{
		/**
		 * 
		 */
		override public function execute (note : INotification) : void
		{
			var projectProxy : ProjectProxy = facade.retrieveProxy( ProjectProxy.NAME ) as ProjectProxy;
			var audioLibraryProxy : AudioLibraryProxy = facade.retrieveProxy( AudioLibraryProxy.NAME ) as AudioLibraryProxy;
			
			if(projectProxy.isBusy || audioLibraryProxy.isBusy)
			{
				/** They're busy. */
				log( "d BusyCommand: Is busy." );
				sendNotification( UINotifications.BUSY_SET, true );
			}
			else
			{
				/** They're not. */
				log( "d BusyCommand: Done, not busy anymore." );
				sendNotification( UINotifications.BUSY_SET, false );
				
				/**
				 * Once all sounds have loaded the instruments that use the 
				 * loaded sounds should get a program change so they get a copy
				 * of the sound from the audio library.
				 */
				projectProxy.finishProjectSetup( );
			}
		}
	}
}
