package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.audio.model.AudioDriverProxy;
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.enum.PlaybackStatus;
	import com.hisschemoller.sequencer.model.vo.PlaybackVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;

	/**
	 * @author wouterhisschemoller
	 */
	public class ChangePlaybackCommand extends SimpleCommand 
	{
		override public function execute ( note : INotification ) : void 
		{
			var playbackStatus : String = note.getBody( ) as String;
			var audioDriverProxy : AudioDriverProxy = facade.retrieveProxy( AudioDriverProxy.NAME ) as AudioDriverProxy;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var playbackVO : PlaybackVO = sequencerProxy.playbackVO;
			
			switch(playbackStatus)
			{
				case PlaybackStatus.PLAYING:
					audioDriverProxy.play( );
					break;
				
				case PlaybackStatus.STOPPED:
					audioDriverProxy.stop( );
					playbackVO.positionInParts = 0;
					sequencerProxy.resetPatterns();
					break;
				
				case PlaybackStatus.PAUSED:
					audioDriverProxy.stop( );
					break;
			}
			
			playbackVO.status = playbackStatus;
			sendNotification( SeqNotifications.SEQ_PLAYBACK_CHANGED, playbackVO.status );
		}
	}
}
