package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.audio.model.AudioDriverProxy;
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.vo.TempoVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;

	/**
	 * @author wouterhisschemoller
	 */
	public class ChangeTempoCommand extends SimpleCommand 
	{
		override public function execute ( note : INotification ) : void 
		{
			var bpm : Number = note.getBody() as Number;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var tempoVO : TempoVO = sequencerProxy.tempoVO;
			
			var millisecondsPerBeat : Number = (60 / bpm) * 1000;
			var millisecondsPerSample : Number = 1000 / AudioDriverProxy.SAMPLE_RATE;
			tempoVO.beatsPerMinute.value = bpm;
			tempoVO.millisecondsPerPart = millisecondsPerBeat / tempoVO.partsPerQuarterNote;
			tempoVO.samplesPerPart = tempoVO.millisecondsPerPart / millisecondsPerSample;

			sendNotification( SeqNotifications.SEQ_TEMPO_CHANGED, tempoVO );
		}
	}
}
