package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.enum.SettingsTab;
	import com.hisschemoller.sequencer.model.vo.PatternVO;
	import com.hisschemoller.sequencer.model.vo.SequenceVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;
	/**
	 * @author wouterhisschemoller
	 */
	public class OpenPatternSettingsCommand extends SimpleCommand 
	{
		override public function execute (note : INotification) : void
		{
			var patternID : String = note.getBody( ) as String;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var sequenceVO : SequenceVO = sequencerProxy.selectedSequence;
			var patternVO : PatternVO;
			
			/** Find the pattern to edit. */
			var n : uint = sequenceVO.patterns.length;
			while(--n > -1)
			{
				if(sequenceVO.patterns[n].id == patternID)
				{
					patternVO = sequenceVO.patterns[n];
					break;
				}
			}
			
			if(patternVO)
			{
				sendNotification( SeqNotifications.SEQ_SHOW_SETTINGS, SettingsTab.PATTERN );
				sendNotification( SeqNotifications.SEQ_SELECT_PATTERN, patternVO );
			}
		}
	}
}
