package com.hisschemoller.sequencer.controller 
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.model.vo.SequenceVO;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;

	/**
	 * @author wouterhisschemoller
	 */
	public class SelectSequenceCommand extends SimpleCommand 
	{
		override public function execute(note : INotification) : void
		{
			var sequenceID : String = note.getBody() as String;
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			var sequences : Vector.<SequenceVO> = sequencerProxy.sequences;
			
			var n : int = sequences.length;
			while(--n > -1)
			{
				if(sequenceID == sequences[n].id)
				{
					sequencerProxy.selectedSequence = sequences[n];
					
					sendNotification( SeqNotifications.SEQ_SEQUENCE_SELECTED, sequences[n] );
					break;
				}
			}
		}
	}
}
