package com.hisschemoller.sequencer.controller
{
	import com.hisschemoller.sequencer.model.SequencerProxy;
	import com.hisschemoller.sequencer.notification.SeqNotifications;

	import org.puremvc.as3.multicore.interfaces.INotification;
	import org.puremvc.as3.multicore.patterns.command.SimpleCommand;
	/**
	 * @author wouter.hisschemoller
	 * Sep 30, 2010
	 * 
	 * Called by the audio driver just before the audio content will be generated.
	 * Here the sequencer can generate it's events.
	 */
	public class WillProcessAudioCommand extends SimpleCommand
	{
		override public function execute(note : INotification) : void 
		{
			var sequencerProxy : SequencerProxy = facade.retrieveProxy( SequencerProxy.NAME ) as SequencerProxy;
			sequencerProxy.process(uint(note.getBody()));
			
			/** Notify PatternEditorMediator to update the time for the locator bar animation. */
			/** Use for global (sequence) time, not pattern specific. */
			sendNotification( SeqNotifications.SEQ_EVENTS_PROCESSED, sequencerProxy.playbackVO );
		}
	}
}
