package com.hisschemoller.sequencer.notification
{
	import com.hisschemoller.audio.notification.AudioNotifications;
	import com.hisschemoller.sequencer.controller.AddNewTrackCommand;
	import com.hisschemoller.sequencer.controller.BusyCommand;
	import com.hisschemoller.sequencer.controller.ChangePlaybackCommand;
	import com.hisschemoller.sequencer.controller.ChangeTempoCommand;
	import com.hisschemoller.sequencer.controller.CreateEventCommand;
	import com.hisschemoller.sequencer.controller.DeleteEventCommand;
	import com.hisschemoller.sequencer.controller.DeleteTrackCommand;
	import com.hisschemoller.sequencer.controller.OpenPatternSettingsCommand;
	import com.hisschemoller.sequencer.controller.SelectSequenceCommand;
	import com.hisschemoller.sequencer.controller.StartupCommand;
	import com.hisschemoller.sequencer.controller.UpdatePatternCommand;
	import com.hisschemoller.sequencer.controller.WillProcessAudioCommand;
	import com.hisschemoller.sequencer.controller.euclid.CreateEuclidPatternCommand;
	import com.hisschemoller.sequencer.controller.euclid.UpdateEuclidPatternCommand;
	import com.hisschemoller.ui.notification.UINotifications;

	import org.puremvc.as3.multicore.patterns.facade.Facade;
	/**
	 * @author wouter.hisschemoller
	 * Sep 30, 2010
	 */
	public class SeqNotifications
	{
		/** Notification name constants. */
		public static const STARTUP : String = "SeqNotifications::STARTUP";
		
		public static const SEQ_SELECT_SEQUENCE : String = "SeqNotifications::SEQ_SELECT_SEQUENCE";
		public static const SEQ_SEQUENCE_SELECTED : String = "SeqNotifications::SEQ_SEQUENCE_SELECTED";
		
		public static const SEQ_CHANGE_PLAYBACK : String = "SeqNotifications::SEQ_CHANGE_PLAYBACK";
		public static const SEQ_PLAYBACK_CHANGED : String = "SeqNotifications::SEQ_PLAYBACK_CHANGED";
		
		public static const SEQ_CHANGE_TEMPO : String = "SeqNotifications::SEQ_CHANGE_TEMPO";
		public static const SEQ_TEMPO_CHANGED : String = "SeqNotifications::SEQ_TEMPO_CHANGED";
		
		public static const SEQ_CREATE_EVENT : String = "SeqNotifications::SEQ_CREATE_EVENT";
		public static const SEQ_EVENT_CREATED : String = "SeqNotifications::SEQ_EVENT_CREATED";
		
		public static const SEQ_DELETE_EVENT : String = "SeqNotifications::SEQ_DELETE_EVENT";
		public static const SEQ_EVENT_DELETED : String = "SeqNotifications::SEQ_EVENT_DELETED";
		
		public static const SEQ_ADD_TRACK : String = "SeqNotifications::SEQ_ADD_TRACK";
		public static const SEQ_TRACK_ADDED : String = "SeqNotifications::SEQ_TRACK_ADDED";
		
		public static const SEQ_UPDATE_PATTERN : String = "SeqNotifications::SEQ_UPDATE_PATTERN";
		// public static const SEQ_PATTERN_UPDATED : String = "SeqNotifications::SEQ_PATTERN_UPDATED";
		
		public static const SEQ_STEP_CHANGE : String = "SeqNotifications::SEQ_STEP_CHANGE";
		public static const SEQ_STEP_CHANGED : String = "SeqNotifications::SEQ_STEP_CHANGED";
		public static const SEQ_EDIT_PATTERN_SETTINGS : String = "SeqNotifications::SEQ_EDIT_PATTERN_SETTINGS";
		public static const SEQ_SHOW_SETTINGS : String = "SeqNotifications::SEQ_SHOW_SETTINGS";
		public static const SEQ_SELECT_PATTERN : String = "SeqNotifications::SEQ_SELECT_PATTERN";
		public static const SEQ_DELETE_TRACK : String = "SeqNotifications::SEQ_DELETE_TRACK";
		public static const SEQ_EVENTS_PROCESSED : String = "SeqNotifications::SEQ_EVENTS_PROCESSED";
		public static const SEQ_UPDATE_PATTERN_VIEW : String = "SeqNotifications::SEQ_UPDATE_PATTERN_VIEW";
		
		public static const SEQ_CREATE_EUCLID_PATTERN : String = "SeqNotifications::SEQ_CREATE_EUCLID_PATTERN";
		public static const SEQ_EUCLID_PATTERN_CREATED : String = "SeqNotifications::SEQ_EUCLID_PATTERN_CREATED";
		
		public static const SEQ_UPDATE_EUCLID_PATTERN : String = "SeqNotifications::SEQ_UPDATE_EUCLID_PATTERN";
		public static const SEQ_EUCLID_PATTERN_UPDATED : String = "SeqNotifications::SEQ_EUCLID_PATTERN_UPDATED";

		public static function initializeController (facade : Facade) : void
		{
			facade.registerCommand( UINotifications.SET_BUSY, BusyCommand );
			facade.registerCommand( AudioNotifications.WILL_PROCESS_AUDIO, WillProcessAudioCommand );
			facade.registerCommand( SeqNotifications.STARTUP, StartupCommand );
			facade.registerCommand( SeqNotifications.SEQ_SELECT_SEQUENCE, SelectSequenceCommand );
			facade.registerCommand( SeqNotifications.SEQ_CHANGE_PLAYBACK, ChangePlaybackCommand );
			facade.registerCommand( SeqNotifications.SEQ_CHANGE_TEMPO, ChangeTempoCommand );
			facade.registerCommand( SeqNotifications.SEQ_CREATE_EVENT, CreateEventCommand );
			facade.registerCommand( SeqNotifications.SEQ_DELETE_EVENT, DeleteEventCommand );
			facade.registerCommand( SeqNotifications.SEQ_EDIT_PATTERN_SETTINGS, OpenPatternSettingsCommand );
			facade.registerCommand( SeqNotifications.SEQ_ADD_TRACK, AddNewTrackCommand );
			facade.registerCommand( SeqNotifications.SEQ_DELETE_TRACK, DeleteTrackCommand );
			facade.registerCommand( SeqNotifications.SEQ_UPDATE_PATTERN, UpdatePatternCommand );
			facade.registerCommand( SeqNotifications.SEQ_CREATE_EUCLID_PATTERN, CreateEuclidPatternCommand );
			facade.registerCommand( SeqNotifications.SEQ_UPDATE_EUCLID_PATTERN, UpdateEuclidPatternCommand );
		}
	}
}
