package com.hisschemoller.sequencer.view.components.settings 
{
	import com.bit101.components.Window;
	import com.hisschemoller.sequencer.model.enum.SettingsTab;
	import com.hisschemoller.sequencer.view.enum.UIEventType;

	import flash.display.DisplayObjectContainer;
	import flash.events.Event;
	import flash.events.MouseEvent;

	/**
	 * @author wouterhisschemoller
	 */
	public class SettingsWindow extends Window 
	{
		public static const PATTERN_WINDOW_INDEX : uint = 0;
		public static const INSTRUMENT_WINDOW_INDEX : uint = 1;
		private var _accordion : SettingsAccordion;

		public function SettingsWindow (parent : DisplayObjectContainer = null, xpos : Number = 0, ypos : Number = 0, title : String = "Window")
		{
			super( parent, xpos, ypos, title );
		}

		public function show ( tab : String ) : void
		{
			visible = true;
			
			switch( tab )
			{
				case SettingsTab.PATTERN:
					_accordion.getWindowAt( PATTERN_WINDOW_INDEX ).dispatchEvent(new Event( Event.SELECT ) );
					break;
					
				case SettingsTab.INSTRUMENT:
					_accordion.getWindowAt( INSTRUMENT_WINDOW_INDEX ).dispatchEvent(new Event( Event.SELECT ) );
					break;
			}
		}

		public function hide () : void
		{
			visible = false;
		}

		/**
		 * 
		 */
		public function addWindow ( window : Window ) : void
		{
			_accordion.addSettingsWindow( window );
		}

		/**
		 * Initializes the component.
		 */
		override protected function init () : void
		{
			super.init( );
			
			hasCloseButton = true;
			grips.visible = true;
			_closeButton.addEventListener( MouseEvent.CLICK, closeClickHandler );
		}

		/**
		 * Creates and adds the child display objects of this component.
		 */
		override protected function addChildren () : void
		{
			super.addChildren( );
			
			_accordion = new SettingsAccordion( this, 0, _titleBar.height );
		}

		/**
		 * Sets the size of the component.
		 * @param w The width of the component.
		 * @param h The height of the component.
		 */
		override public function setSize ( w : Number, h : Number ) : void
		{
			super.setSize( w, h );
			
			_accordion.setSize( w, h );
		}

		/**
		 * 
		 */
		private function closeClickHandler ( event : MouseEvent ) : void 
		{
			dispatchEvent( new Event( UIEventType.SETTINGS_CLOSE ) );
		}
	}
}
