package com.hisschemoller.ui.view.components 
{
	import com.bit101.components.Component;
	import com.bit101.components.PushButton;
	import com.bit101.components.Text;
	import com.bit101.components.Window;

	import flash.display.DisplayObjectContainer;
	import flash.events.MouseEvent;

	/**
	 * @author Wouter Hisschemoller
	 * Jan 23, 2010
	 */
	public class Alert extends Component 
	{
		private var _window : Window;
		private var _closeButton : PushButton;
		private var _text : Text;

		public function Alert ( container : DisplayObjectContainer = null )
		{
			super( container );
		}

		/**
		 * 
		 */
		public function show (header : String, message : String) : void
		{
			/** Get on top. */
			if(parent)
			{
				parent.addChild( this );
			}
			
			_window.visible = true;
			_window.title = header;
			_text.text = message;
		}

		/**
		 * 
		 */
		public function hide () : void
		{
			_window.visible = false;
		}

		/**
		 * 
		 */
		override protected function init () : void
		{
			super.init( );
			hide( );
		}

		/**
		 * 
		 */
		override protected function addChildren () : void
		{
			super.addChildren( );
			
			_window = new Window( this, 10, 30, "Alert" );
			_window.setSize( 200, 150 );
			
			_text = new Text( _window, 0, 20 );
			_text.setSize( 200, 90 );
			_text.selectable = false;
			_text.html = true;
			
			_closeButton = new PushButton( _window, 120, 120, "Close", closeClickHandler );
			_closeButton.x = (_window.width / 2) - (_closeButton.width / 2);
		}

		/**
		 * 
		 */
		private function closeClickHandler (inEvent : MouseEvent) : void
		{
			hide( );
		}
	}
}
