
package com.hisschemoller.utils 
{

	/**
	 * @author Wouter Hisschemoller
	 * (c) May 18, 2011
	 */
	public class EuclidGenerator
	{
		private var _pattern : Vector.<Boolean> = new Vector.<Boolean>( );

		public function EuclidGenerator ( total : int, hits : int )
		{
			if ( hits >= total || hits == 1 || hits == 0 )
			{
				_pattern = new Vector.<Boolean>( );
				if ( hits >= total )
				{
					for ( var i : int = 0; i < total; i ++ )
					{
						_pattern.push( true );
					}
				}
				else if ( total == 1 )
				{
					_pattern.push( hits == 1 );
				}
				else
				{
					for ( i = 0; i < total; i ++ )
					{
						_pattern.push( false );
					}
				}
				
				return;
			}
			
			var bigArray : Vector.<Vector.<Boolean>> = new Vector.<Vector.<Boolean>>( );
			for ( i = 0; i < hits; i ++ )
			{
				var boolArray : Vector.<Boolean> = new Vector.<Boolean>( );
				boolArray.push( true );
				bigArray.push( boolArray );
			}
	
			var smallArray : Vector.<Vector.<Boolean>> = new Vector.<Vector.<Boolean>>( );
			for ( i = 0; i < ( total - hits ); i ++ )
			{
				boolArray = new Vector.<Boolean>( );
				boolArray.push( false );
				smallArray.push( boolArray );
			}
			
			_pattern = bjorklund( bigArray, smallArray );
		}

		public function get pattern () : Vector.<Boolean>
		{
			return _pattern;
		}

		private function bjorklund ( bigArray : Vector.<Vector.<Boolean>>, smallArray : Vector.<Vector.<Boolean>> ) : Vector.<Boolean>
		{
			/** Done, flatten arrays. */
			if ( smallArray.length <= 1 )
			{
				var resultList : Vector.<Boolean> = new Vector.<Boolean>( );
				for ( var i : int = 0; i < bigArray.length; i ++ )
				{
					for ( var j : int = 0; j < bigArray[ i ].length; j ++ )
					{
						resultList.push( bigArray[ i ][ j ] );
					}
				}
				for ( i = 0; i < smallArray.length; i ++ )
				{
					for ( j = 0; j < smallArray[ i ].length; j ++ )
					{
						resultList.push( smallArray[i][j] );
					}
				}
				return resultList;
			}

			var fullRounds : int = Math.floor( smallArray.length / bigArray.length );
			for ( i = 0; i < fullRounds; i ++ )
			{
				for ( j = 0; j < bigArray.length; j ++ )
				{
					var sourceBoolArray : Vector.<Boolean> = smallArray[0];
					for ( var k : int = 0; k < sourceBoolArray.length; k ++ )
					{
						bigArray[j].push( sourceBoolArray[k] );
					}
					smallArray.splice( 0, 1 );
				}
			}

			var remainder : int = smallArray.length % bigArray.length;
			for ( i = 0; i < remainder; i ++ )
			{
				sourceBoolArray = smallArray[0];
				for ( k = 0; k < sourceBoolArray.length; k ++ )
				{
					bigArray[i].push( sourceBoolArray[k] );
				}
				smallArray.splice( 0, 1 );
			}

			/** Split result in two new arrays. */
			var newBigArray : Vector.<Vector.<Boolean>> = new Vector.<Vector.<Boolean>>( );
			var newSmallArray : Vector.<Vector.<Boolean>> = new Vector.<Vector.<Boolean>>( );
			for ( i = 0; i < bigArray.length; i ++ )
			{
				if ( remainder == 0 )
				{
					newBigArray.push( bigArray[i] );
				}
				else
				{
					if ( i < remainder )
					{
						newBigArray.push( bigArray[i] );
					}
					else
					{
						newSmallArray.push( bigArray[i] );
					}
				}
			}
			
			return bjorklund( newBigArray, newSmallArray );
		}
	}
}
